<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<meta name="robots" content="NOINDEX, NOFOLLOW" /> <!-- Prevent indexing by search engines -->
<title>ARM Compute Library: arm_compute/runtime/CL/CLArray.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script><script type="text/javascript" src="http://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">ARM Compute Library
   &#160;<span id="projectnumber">17.04</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.xhtml"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.xhtml"><span>Namespaces</span></a></li>
      <li><a href="annotated.xhtml"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.xhtml"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.xhtml"><span>File&#160;List</span></a></li>
      <li><a href="globals.xhtml"><span>Globals</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_c_l_array_8h_source.xhtml','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">CLArray.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_c_l_array_8h.xhtml">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (c) 2016, 2017 ARM Limited.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * SPDX-License-Identifier: MIT</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * Permission is hereby granted, free of charge, to any person obtaining a copy</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> * of this software and associated documentation files (the &quot;Software&quot;), to</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> * deal in the Software without restriction, including without limitation the</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * sell copies of the Software, and to permit persons to whom the Software is</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * furnished to do so, subject to the following conditions:</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * The above copyright notice and this permission notice shall be included in all</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> * copies or substantial portions of the Software.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> * THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> * SOFTWARE.</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#ifndef __ARM_COMPUTE_CLARRAY_H__</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#define __ARM_COMPUTE_CLARRAY_H__</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_i_c_l_array_8h.xhtml">arm_compute/core/CL/ICLArray.h</a>&quot;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_open_c_l_8h.xhtml">arm_compute/core/CL/OpenCL.h</a>&quot;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_error_8h.xhtml">arm_compute/core/Error.h</a>&quot;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_types_8h.xhtml">arm_compute/core/Types.h</a>&quot;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_c_l_scheduler_8h.xhtml">arm_compute/runtime/CL/CLScheduler.h</a>&quot;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacearm__compute.xhtml">arm_compute</a></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;{</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="classarm__compute_1_1_c_l_array.xhtml">   37</a></span>&#160;<span class="keyword">class </span><a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLArray</a> : <span class="keyword">public</span> <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLArray</a>&lt;T&gt;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;{</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <a class="code" href="classarm__compute_1_1_c_l_array.xhtml#aa5da2a7afb0be8e26c7159bce08bd897">CLArray</a>(<span class="keyword">const</span> <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLArray</a> &amp;) = <span class="keyword">delete</span>;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keyword">const</span> <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLArray</a> &amp;<a class="code" href="classarm__compute_1_1_c_l_array.xhtml#a30c5bc8ac7572a16644c3c88daa90f49">operator=</a>(<span class="keyword">const</span> <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLArray</a> &amp;) = <span class="keyword">delete</span>;</div><div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="classarm__compute_1_1_c_l_array.xhtml#aaa923d0abf2a3a5722a728f39411ad07">   48</a></span>&#160;    <a class="code" href="classarm__compute_1_1_c_l_array.xhtml#aaa923d0abf2a3a5722a728f39411ad07">CLArray</a>(<span class="keywordtype">size_t</span> <a class="code" href="classarm__compute_1_1_i_array.xhtml#a2ff0fb106d58091d2b4363e808f200a3">max_num_values</a>)</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        : <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLArray</a>&lt;T&gt;(max_num_values), _buffer(<a class="code" href="namespacecl.xhtml">cl</a>::Buffer(<a class="code" href="classarm__compute_1_1_c_l_scheduler.xhtml">CLScheduler</a>::get().context(), CL_MEM_ALLOC_HOST_PTR | CL_MEM_READ_WRITE, max_num_values * sizeof(T)))</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    {</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    }</div><div class="line"><a name="l00058"></a><span class="lineno"><a class="line" href="classarm__compute_1_1_c_l_array.xhtml#a14c53d2d17be6fa8a2c9861527c7b002">   58</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classarm__compute_1_1_c_l_array.xhtml#a14c53d2d17be6fa8a2c9861527c7b002">map</a>(<span class="keywordtype">bool</span> blocking = <span class="keyword">true</span>)</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    {</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml#ac0abc7a5c0d172947f0e6a0c0dde3df0">ICLArray&lt;T&gt;::map</a>(<a class="code" href="classarm__compute_1_1_c_l_scheduler.xhtml#a60f9a6836b628a7171914c4afe43b4a7">CLScheduler::get</a>().queue(), blocking);</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    }</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLArray&lt;T&gt;::map</a>;</div><div class="line"><a name="l00068"></a><span class="lineno"><a class="line" href="classarm__compute_1_1_c_l_array.xhtml#a1ffeb3b5abb3d61f62b58a391816201c">   68</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classarm__compute_1_1_c_l_array.xhtml#a1ffeb3b5abb3d61f62b58a391816201c">unmap</a>()</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    {</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml#af974a2360069c2ef8df4496d00e4f6cc">ICLArray&lt;T&gt;::unmap</a>(<a class="code" href="classarm__compute_1_1_c_l_scheduler.xhtml#a60f9a6836b628a7171914c4afe43b4a7">CLScheduler::get</a>().queue());</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    }</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_i_c_l_array.xhtml">ICLArray&lt;T&gt;::unmap</a>;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="comment">// Inherited methods overridden:</span></div><div class="line"><a name="l00075"></a><span class="lineno"><a class="line" href="classarm__compute_1_1_c_l_array.xhtml#afd44a3d7dad6d984b1b87bc9f1b4fa02">   75</a></span>&#160;    <span class="keyword">const</span> cl::Buffer &amp;<a class="code" href="classarm__compute_1_1_c_l_array.xhtml#afd44a3d7dad6d984b1b87bc9f1b4fa02">cl_buffer</a>()<span class="keyword"> const override</span></div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="keyword">    </span>{</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        <span class="keywordflow">return</span> _buffer;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    }</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="keyword">protected</span>:</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <span class="comment">// Inherited methods overridden:</span></div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    uint8_t *do_map(cl::CommandQueue &amp;q, <span class="keywordtype">bool</span> blocking)<span class="keyword"> override</span></div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="keyword">    </span>{</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        <a class="code" href="_error_8h.xhtml#a54a6080c9f4df1f908e57a9bbb46f5da">ARM_COMPUTE_ERROR_ON</a>(<span class="keyword">nullptr</span> == _buffer.get());</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span>uint8_t *<span class="keyword">&gt;</span>(q.enqueueMapBuffer(_buffer, blocking ? CL_TRUE : CL_FALSE, CL_MAP_READ | CL_MAP_WRITE, 0, this-&gt;<a class="code" href="classarm__compute_1_1_i_array.xhtml#a2ff0fb106d58091d2b4363e808f200a3">max_num_values</a>() * <span class="keyword">sizeof</span>(T)));</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    }</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <span class="keywordtype">void</span> do_unmap(cl::CommandQueue &amp;q, uint8_t *mapping)<span class="keyword"> override</span></div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="keyword">    </span>{</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <a class="code" href="_error_8h.xhtml#a54a6080c9f4df1f908e57a9bbb46f5da">ARM_COMPUTE_ERROR_ON</a>(<span class="keyword">nullptr</span> == _buffer.get());</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;        q.enqueueUnmapMemObject(_buffer, mapping);</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    }</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    cl::Buffer _buffer;</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;};</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a55e1c5ed17b7ee3762198a38eb50650a">   97</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLKeyPointArray</a>        = <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLArray&lt;KeyPoint&gt;</a>;</div><div class="line"><a name="l00098"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a0fd5f0310a26faad00b905bac3792726">   98</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLCoordinates2DArray</a>   = <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLArray&lt;Coordinates2D&gt;</a>;</div><div class="line"><a name="l00099"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#ab8d2c7efb7643ce8f9e5446dbe1da0b4">   99</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLDetectionWindowArray</a> = <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLArray&lt;DetectionWindow&gt;</a>;</div><div class="line"><a name="l00100"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a3f9ab729931f4e4fa36ff1683186d988">  100</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLSize2DArray</a>          = <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLArray&lt;Size2D&gt;</a>;</div><div class="line"><a name="l00101"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#aa031694bb03711e09e25546ad2b643cc">  101</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLUInt8Array</a>           = <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLArray&lt;cl_uchar&gt;</a>;</div><div class="line"><a name="l00102"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a7b4c4a79c73a3f85ba89aff03fddefa7">  102</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLUInt16Array</a>          = <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLArray&lt;cl_ushort&gt;</a>;</div><div class="line"><a name="l00103"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a1d7d89b7e990055dc95ed37dfb24da48">  103</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLUInt32Array</a>          = <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLArray&lt;cl_uint&gt;</a>;</div><div class="line"><a name="l00104"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a5fb8cb339705102066c915d18f0701ac">  104</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLInt16Array</a>           = <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLArray&lt;cl_short&gt;</a>;</div><div class="line"><a name="l00105"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a8a401a071524761c661a75969c951cf5">  105</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLInt32Array</a>           = <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLArray&lt;cl_int&gt;</a>;</div><div class="line"><a name="l00106"></a><span class="lineno"><a class="line" href="namespacearm__compute.xhtml#a193a4859b365f3ef4e0d73a1e6b12c85">  106</a></span>&#160;<span class="keyword">using</span> <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLFloatArray</a>           = <a class="code" href="classarm__compute_1_1_c_l_array.xhtml">CLArray&lt;cl_float&gt;</a>;</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;}</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* __ARM_COMPUTE_CLARRAY_H__ */</span><span class="preprocessor"></span></div><div class="ttc" id="namespacecl_xhtml"><div class="ttname"><a href="namespacecl.xhtml">cl</a></div><div class="ttdef"><b>Definition:</b> <a href="_i_c_l_distribution1_d_8h_source.xhtml#l00032">ICLDistribution1D.h:32</a></div></div>
<div class="ttc" id="_i_c_l_array_8h_xhtml"><div class="ttname"><a href="_i_c_l_array_8h.xhtml">ICLArray.h</a></div></div>
<div class="ttc" id="_types_8h_xhtml"><div class="ttname"><a href="_types_8h.xhtml">Types.h</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_c_l_array_xhtml_ac0abc7a5c0d172947f0e6a0c0dde3df0"><div class="ttname"><a href="classarm__compute_1_1_i_c_l_array.xhtml#ac0abc7a5c0d172947f0e6a0c0dde3df0">arm_compute::ICLArray::map</a></div><div class="ttdeci">void map(cl::CommandQueue &amp;q, bool blocking=true)</div><div class="ttdoc">Enqueue a map operation of the allocated buffer on the given queue. </div><div class="ttdef"><b>Definition:</b> <a href="_i_c_l_array_8h_source.xhtml#l00061">ICLArray.h:61</a></div></div>
<div class="ttc" id="classarm__compute_1_1_c_l_array_xhtml_afd44a3d7dad6d984b1b87bc9f1b4fa02"><div class="ttname"><a href="classarm__compute_1_1_c_l_array.xhtml#afd44a3d7dad6d984b1b87bc9f1b4fa02">arm_compute::CLArray::cl_buffer</a></div><div class="ttdeci">const cl::Buffer &amp; cl_buffer() const override</div><div class="ttdoc">Interface to be implemented by the child class to return a reference to the OpenCL buffer containing ...</div><div class="ttdef"><b>Definition:</b> <a href="_c_l_array_8h_source.xhtml#l00075">CLArray.h:75</a></div></div>
<div class="ttc" id="_error_8h_xhtml_a54a6080c9f4df1f908e57a9bbb46f5da"><div class="ttname"><a href="_error_8h.xhtml#a54a6080c9f4df1f908e57a9bbb46f5da">ARM_COMPUTE_ERROR_ON</a></div><div class="ttdeci">#define ARM_COMPUTE_ERROR_ON(cond)</div><div class="ttdoc">If the condition is true then an error message is printed and an exception thrown. </div><div class="ttdef"><b>Definition:</b> <a href="_error_8h_source.xhtml#l00100">Error.h:100</a></div></div>
<div class="ttc" id="namespacearm__compute_xhtml"><div class="ttname"><a href="namespacearm__compute.xhtml">arm_compute</a></div><div class="ttdef"><b>Definition:</b> <a href="arm__compute_8dox_source.xhtml#l00001">arm_compute.dox:1</a></div></div>
<div class="ttc" id="_c_l_scheduler_8h_xhtml"><div class="ttname"><a href="_c_l_scheduler_8h.xhtml">CLScheduler.h</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_c_l_array_xhtml"><div class="ttname"><a href="classarm__compute_1_1_i_c_l_array.xhtml">arm_compute::ICLArray</a></div><div class="ttdoc">Interface for OpenCL Array. </div><div class="ttdef"><b>Definition:</b> <a href="_i_c_l_array_8h_source.xhtml#l00035">ICLArray.h:35</a></div></div>
<div class="ttc" id="classarm__compute_1_1_c_l_scheduler_xhtml_a60f9a6836b628a7171914c4afe43b4a7"><div class="ttname"><a href="classarm__compute_1_1_c_l_scheduler.xhtml#a60f9a6836b628a7171914c4afe43b4a7">arm_compute::CLScheduler::get</a></div><div class="ttdeci">static CLScheduler &amp; get()</div><div class="ttdoc">Access the scheduler singleton. </div></div>
<div class="ttc" id="classarm__compute_1_1_c_l_array_xhtml_a14c53d2d17be6fa8a2c9861527c7b002"><div class="ttname"><a href="classarm__compute_1_1_c_l_array.xhtml#a14c53d2d17be6fa8a2c9861527c7b002">arm_compute::CLArray::map</a></div><div class="ttdeci">void map(bool blocking=true)</div><div class="ttdoc">Enqueue a map operation of the allocated buffer. </div><div class="ttdef"><b>Definition:</b> <a href="_c_l_array_8h_source.xhtml#l00058">CLArray.h:58</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_array_xhtml_a2ff0fb106d58091d2b4363e808f200a3"><div class="ttname"><a href="classarm__compute_1_1_i_array.xhtml#a2ff0fb106d58091d2b4363e808f200a3">arm_compute::IArray::max_num_values</a></div><div class="ttdeci">size_t max_num_values() const </div><div class="ttdoc">Maximum number of values which can be stored in this array. </div><div class="ttdef"><b>Definition:</b> <a href="_i_array_8h_source.xhtml#l00058">IArray.h:58</a></div></div>
<div class="ttc" id="classarm__compute_1_1_c_l_array_xhtml_aaa923d0abf2a3a5722a728f39411ad07"><div class="ttname"><a href="classarm__compute_1_1_c_l_array.xhtml#aaa923d0abf2a3a5722a728f39411ad07">arm_compute::CLArray::CLArray</a></div><div class="ttdeci">CLArray(size_t max_num_values)</div><div class="ttdoc">Constructor: initializes an array which can contain up to max_num_points values. </div><div class="ttdef"><b>Definition:</b> <a href="_c_l_array_8h_source.xhtml#l00048">CLArray.h:48</a></div></div>
<div class="ttc" id="_error_8h_xhtml"><div class="ttname"><a href="_error_8h.xhtml">Error.h</a></div></div>
<div class="ttc" id="classarm__compute_1_1_i_c_l_array_xhtml_af974a2360069c2ef8df4496d00e4f6cc"><div class="ttname"><a href="classarm__compute_1_1_i_c_l_array.xhtml#af974a2360069c2ef8df4496d00e4f6cc">arm_compute::ICLArray::unmap</a></div><div class="ttdeci">void unmap(cl::CommandQueue &amp;q)</div><div class="ttdoc">Enqueue an unmap operation of the allocated and mapped buffer on the given queue. ...</div><div class="ttdef"><b>Definition:</b> <a href="_i_c_l_array_8h_source.xhtml#l00072">ICLArray.h:72</a></div></div>
<div class="ttc" id="classarm__compute_1_1_c_l_array_xhtml_aa5da2a7afb0be8e26c7159bce08bd897"><div class="ttname"><a href="classarm__compute_1_1_c_l_array.xhtml#aa5da2a7afb0be8e26c7159bce08bd897">arm_compute::CLArray::CLArray</a></div><div class="ttdeci">CLArray(const CLArray &amp;)=delete</div><div class="ttdoc">Prevent instances of this class from being copied (As this class contains pointers) ...</div></div>
<div class="ttc" id="classarm__compute_1_1_c_l_scheduler_xhtml"><div class="ttname"><a href="classarm__compute_1_1_c_l_scheduler.xhtml">arm_compute::CLScheduler</a></div><div class="ttdoc">Provides global access to a CL context and command queue. </div><div class="ttdef"><b>Definition:</b> <a href="_c_l_scheduler_8h_source.xhtml#l00035">CLScheduler.h:35</a></div></div>
<div class="ttc" id="_open_c_l_8h_xhtml"><div class="ttname"><a href="_open_c_l_8h.xhtml">OpenCL.h</a></div></div>
<div class="ttc" id="classarm__compute_1_1_c_l_array_xhtml"><div class="ttname"><a href="classarm__compute_1_1_c_l_array.xhtml">arm_compute::CLArray</a></div><div class="ttdoc">CLArray implementation. </div><div class="ttdef"><b>Definition:</b> <a href="_c_l_array_8h_source.xhtml#l00037">CLArray.h:37</a></div></div>
<div class="ttc" id="classarm__compute_1_1_c_l_array_xhtml_a30c5bc8ac7572a16644c3c88daa90f49"><div class="ttname"><a href="classarm__compute_1_1_c_l_array.xhtml#a30c5bc8ac7572a16644c3c88daa90f49">arm_compute::CLArray::operator=</a></div><div class="ttdeci">const CLArray &amp; operator=(const CLArray &amp;)=delete</div><div class="ttdoc">Prevent instances of this class from being copied (As this class contains pointers) ...</div></div>
<div class="ttc" id="classarm__compute_1_1_c_l_array_xhtml_a1ffeb3b5abb3d61f62b58a391816201c"><div class="ttname"><a href="classarm__compute_1_1_c_l_array.xhtml#a1ffeb3b5abb3d61f62b58a391816201c">arm_compute::CLArray::unmap</a></div><div class="ttdeci">void unmap()</div><div class="ttdoc">Enqueue an unmap operation of the allocated and mapped buffer. </div><div class="ttdef"><b>Definition:</b> <a href="_c_l_array_8h_source.xhtml#l00068">CLArray.h:68</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_214608ef36d61442cb2b0c1c4e9a7def.xhtml">arm_compute</a></li><li class="navelem"><a class="el" href="dir_8bc26130589aa16388b5a02f17abf2c2.xhtml">runtime</a></li><li class="navelem"><a class="el" href="dir_b986aa98f9b6490bb4fc7918500346fb.xhtml">CL</a></li><li class="navelem"><a class="el" href="_c_l_array_8h.xhtml">CLArray.h</a></li>
    <li class="footer">Generated on Wed Apr 12 2017 17:30:09 for ARM Compute Library by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
